﻿using Syncfusion.Windows.Forms.Grid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace EditCell
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            //In FormLoad
            //Register the custom CellModel 
            this.gridControl1.Model.CellModels.Add("ComboBoxButtonEditCell", new ComboCellModel(this.gridControl1.Model));
            //Setting the CellType 
            this.gridControl1[2, 3].CellType = "ComboBoxButtonEditCell";

            //Get the ComboCellRenderer
            ComboCellRenderer renderer = gridControl1.GetCellRenderer(2, 3) as ComboCellRenderer;
            //Invoke the button clicked event
            renderer.button.Clicked += button_Clicked;
            
        
        }

        void button_Clicked(object sender, GridCellEventArgs e)
        {
            MessageBox.Show(String.Format("Pressed Button at ({0},{1})", e.RowIndex, e.ColIndex));
        }

}

    //Custom cellModel 
    class ComboCellModel : GridComboBoxCellModel
    {
        public ComboCellModel(GridModel grid)
            : base(grid)
        {
            //Set the size of the button bar.
            ButtonBarSize = new System.Drawing.Size(30, 15);
        }
        public override GridCellRendererBase CreateRenderer(GridControlBase control)
        {
            return new ComboCellRenderer(control, this);
        }
    }

    //Custom cellRenderer
    class ComboCellRenderer : GridComboBoxCellRenderer
    {
        public GridCellButton button;
        public ComboCellRenderer(GridControlBase control, GridCellModelBase model)
            : base(control, model)
        {
            button = new GridCellButton(this);
            
            //Add the button to the comboBox cell
            this.AddButton(button);
        }
    }
}
